/* ========================================
 *  StudioTan - StudioTan.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __StudioTan_StudioTan_H
#define __StudioTan_StudioTan_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::StudioTan {
enum {
	kParamA = 0,
  kNumParameters = 1
}; //


class StudioTan final : public SfxCoreExtensionV1
{
public:
    StudioTan();
    ~StudioTan();
    void processBlock(float** inputs, float** outputs, int sampleFrames) override;
    int getParameterCount() const override;
    float getParameter(int index) override;
    void setParameter(int index, float value) override;
    void getParameterLabel(int index, char *text) override;
    void getParameterName(int index, char *text) override;
    void getParameterDisplay(int index, char *text) override;
private:
    
	double bynL[13];
	double noiseShapingL;
	double lastSampleL;
	double lastSample2L;

	double bynR[13];
	double noiseShapingR;
	double lastSampleR;
	double lastSample2R;
	
    float A;

};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
